// Gateway URL for API calls
// var gatewayURL = 'http://192.168.200.5:10080/samwayp/STREAMAPI/public/index.php'; // TEST
// var gatewayURL = 'http://www.demo.go2stream.net:10080/STREAMAPI'; // DEMO
var gatewayURL = 'http://www.go2stream.net/STREAMAPI'; // LIVE

var startDate;

$(document).ready(function() {

	$('#LogIn').bind('click', postLogin);
	$('#SubmitChecks').bind('click', postSubmitChecks);
	$('#goHome').bind('click', s1display);
	$('#privacyPolicyShow').bind('click', privacyPolicy);
	document.addEventListener("backbutton", function(e) {
		navigator.app.exitApp();
	}, false);
	document.addEventListener("deviceready", hideStatusBar, false);
	$('input').bind('focus', positionInput);
	
});


/**
 * Sends POST /login[/:login_id] to API gateway.
 * 
 * This method is automatically generated. Don't modify it. Application logic
 * for handling the AJAX response should be placed in
 * <code>onPostLogin</code>.
 */
function postLogin() {
	
	if ($('#driver').val()=='' || $('#registration').val()=='' || $('#mileage').val()=='' || isNaN($('#mileage').val())){
		$('#loginResult').text('All fields must be entered and mileage must be numeric');
	} else {
	
		// This method is automatically generated. Don't modify it.
		jQuery.mobile.showPageLoadingMsg('Loading');
		$(window).scrollTop(0);
		$.ajax({
			url : gatewayURL + '/walkaround-driver-validation',
			cache : false,
			type : 'POST',
			contentType : 'application/json',
			data : JSON.stringify({
				'user' : $('#driver').val(),
				'vehicleReg' : $('#registration').val(),
				'mileage' : $('#mileage').val(),
			}),
			success : function(data, status, xhr) {
					jQuery.mobile.hidePageLoadingMsg();
					onPostLogin(JSON.parse(data));
				}
		});
	}
}


/**
 * Handle AJAX response for POST /login[/:login_id]
 * 
 * @param response JSON object with response
 */
function onPostLogin(response) {
	
	var valid = response.isValid;
	var err = response.error;
	var check = response.checkList;

	if(!valid){
		$('#loginResult').text(err);
	}
	else {
		startDate = new Date();
		s2display(check);
	} 
}


//Display Screen 1 
function s1display() {

	$('#driver').val('');
	$('#registration').val('');
	$('#mileage').val('');
	$('#loginResult').text('');
	$('#nil').val('');
	$('#reportedTo').val('');
	
	$('#checkDiv').remove();
	// Display the view
	$.mobile.changePage('#page1');
	
} 


//Display Screen 2 
function s2display(checkArray) {

	$('#checkDiv').remove();
	var numChecks = checkArray.length;
	html = '<div data-role="content" id="checkDiv">';
	
	// Headers and details...
	for (var i=0; i<numChecks; i++) {
		var check = checkArray[i];

		if(check.detailSeq==0){
			html += '<h2>' + check.desc + '</h2>';
		} else {	
			html += '<h3 id="titleH' + check.headerSeq + 'D' + check.detailSeq +'">' + check.desc + '</h3>';
			var detailAdd = 'H' + check.headerSeq + 'D' + check.detailSeq;
		html += '<div class="radioChecks" id="H' + check.headerSeq + 'D' + check.detailSeq + '" data-role="fieldcontain"><fieldset data-role="controlgroup" data-type="horizontal">' 
	         + 	'<input class="radioCheck" type="radio" name="H' + check.headerSeq + 'D' + check.detailSeq + 'F" id="radioH' + check.headerSeq + 'D' + check.detailSeq + 'F" value="choiceH' + check.headerSeq + 'D' + check.detailSeq + '-F" onclick="openDetails('+detailAdd+', '+check.headerSeq+', '+check.detailSeq+')" />'
	         +	'<label for="radioH' + check.headerSeq + 'D' + check.detailSeq + 'F"><img src="style/images/cross240.png"></label>'
	         +	'<input class="radioCheck" type="radio" name="H' + check.headerSeq + 'D' + check.detailSeq + 'P" id="radioH' + check.headerSeq + 'D' + check.detailSeq + 'P" value="choiceH' + check.headerSeq + 'D' + check.detailSeq + '-P" onclick="closeDetails('+check.headerSeq+', '+check.detailSeq+')" />'
	         +	'<label for="radioH' + check.headerSeq + 'D' + check.detailSeq + 'P"><img src="style/images/tick240.png"></label></fieldset></div>';
		}
	}
	html += '</div>';

	
	$('#checks').append(html);
	
	// Display the view
	$.mobile.changePage('#page2');
	$("input[type='radio']").checkboxradio();
	$('#checks').trigger('create');
	
} 


//Add a details box
function openDetails(targetId, hd, dt) {
	
	hdr = (hd < 10) ? ("0" + hd) : hd;
	dtl = (dt < 10) ? ("0" + dt) : dt;

	// @@TODO: Check with Alex that this is right!
	if($('#headerH'+hdr+'D'+dtl).length>0) {
		return;
	}
	
	html = '<h3 id="headerH'+hdr+'D'+dtl+'">Defect Details</h3><div data-role="fieldcontain" data-controltype="textinput">'
	 + '<textarea style="width: 100%" class="defects" id="detailH'+hdr+'D'+dtl+'" rows="4" placeholder=""></textarea></div>'
	 + '<div data-role="fieldcontain">'
	 + '<a id="cameraH'+hdr+'D'+dtl+'" href="#" data-role="button" onclick="capturePhoto('+hdr+', '+dtl+');">Capture Photo</a>'
	 + '<div id="galleryH'+hdr+'D'+dtl+'" style="display: none;" data-imagecount="0"></div>'
	 + '</div>';
	
	$(targetId).append(html);
	var detailDel = '#detailH'+hdr+'D'+dtl;
	$(detailDel).focus();
	var headerDel = '#titleH'+hdr+'D'+dtl;
	
	$('html, body').animate({
		scrollTop: $(headerDel).offset().top
	});
	
	var checkbox = '#radioH'+hdr+'D'+dtl+'P';
	$(checkbox).attr('checked', false);
	$(checkbox).removeClass("ui-radio-on");
	$(checkbox).addClass("ui-radio-off");
	$(checkbox).checkboxradio("refresh");
	var button = '#cameraH'+hdr+'D'+dtl;
	$(button).buttonMarkup();
} 


//Remove a details box
function closeDetails(hd, dt) {
	
	$( ".defects" ).blur();
	
	hdr = (hd < 10) ? ("0" + hd) : hd;
	dtl = (dt < 10) ? ("0" + dt) : dt;
	
	var headerDel = '#headerH'+hdr+'D'+dtl;
	$(headerDel).remove();
	var detailDel = '#detailH'+hdr+'D'+dtl;
	$(detailDel).remove();
	var cameraDel = '#cameraH'+hdr+'D'+dtl;
	$(cameraDel).remove();
	var galleryDel = '#galleryH'+hdr+'D'+dtl;
	$(galleryDel).remove();
	
	var checkbox = '#radioH'+hdr+'D'+dtl+'F';
	$(checkbox).attr('checked', false);
	$(checkbox).removeClass("ui-radio-on");
	$(checkbox).addClass("ui-radio-off");
	$(checkbox).checkboxradio("refresh");
} 


/**
 * Capture a photo
 */
function capturePhoto(hd, dt) {

	hdr = (hd < 10) ? ("0" + hd) : hd;
	dtl = (dt < 10) ? ("0" + dt) : dt;

	var galleryId = '#galleryH'+hdr+'D'+dtl;
	
	id = parseInt($(galleryId).attr('data-imagecount'));
	id += 1;
	
	idx = (id < 10) ? ("0" + id) : id;
	
	var thumbId = "#thumbH"+hdr+"D"+dtl+"I"+idx;

	var options = {
		correctOrientation: true,		// only works for JPEG images, not PNG, so that's why we use JPEG!
		//saveToPhotoAlbum: true,		// enable if a copy of images is required in the device gallery
	};
	
	// Note: The version of the cordova-plugin-camera currently used is 2.3.0
	navigator.camera.getPicture(
		function(imageData){saveImage(imageData, galleryId, thumbId, id);},
		cameraError,
		options
	);
}


/**
 * Store an image link and thumbnail
 */
function saveImage(imageData, galleryId, thumbId, imageCount) {
	
	// Update the image count
	$(galleryId).attr('data-imagecount', imageCount);
	
	// Add a thumbnail to the relevant gallery div
	html = '<img id="'+thumbId+'" class="capturedImage" src="'+imageData+'" style="height: 20%; width: 20%; margin: 5px;" />';
	$(galleryId).append(html).show();
}


/**
 * Handle camera error
 */
function cameraError(e) {
	// Catch cancel
	if(e.toUpperCase().search("CANCEL")!=-1)
		return;
	
	// Assume permission problem
	alert("Unable to launch camera - check that all app permissions are enabled");
}

/**
 */
function postSubmitChecks() {
	
	var err = '';
	$(".defects").each(function(i, obj) {
		if ($(this).val().replace(/ /g,'') == ''){
			err = 'Defect details must be entered for all failed checks.  ';
			return false;
		}
	});
	
	gotFail = false;
	$(".radioChecks").each(function(i, obj) {
		HDid = this.id;
		HDfailid = '#radio'+HDid+'F';
		HDpassid = '#radio'+HDid+'P';
		
		if (!$(HDfailid).is(':checked') && !$(HDpassid).is(':checked')){
			err += ' All checks must be performed.';
			return false;
		}
		if ($(HDfailid).is(':checked')){
			gotFail = true;
		}
	});
	
	if ($('#nil').val().replace(/ /g,'')=='' && gotFail == false){
		err += ' NIL must be entered if no defects.';
	}
	if ($('#nil').val().replace(/ /g,'')!='' && gotFail == true){
		err += ' NIL must not be entered if defects.';
	}
	if ($('#reportedTo').val().replace(/ /g,'')=='' && gotFail == true){
		err += ' Reported To must be entered if defects.';
	}
	if ($('#reportedTo').val().replace(/ /g,'')!='' && gotFail == false){
		err += ' Reported To is not required if no defects.';
	}
	

	if (err !=''){
		$('#SubmitErrors').text(err);
	} else {
		$('#SubmitErrors').text('');
		jQuery.mobile.showPageLoadingMsg('Loading');
		
		postImages();
		
		var resultArray = [];
		var j = 0;
		$(".radioCheck").each(function(i, obj) {
			if ($(this).is(':checked')){
				resultArray[j] = this.id;
				j++;
			}
		});
		
		var detailsArray = [];
		var j = 0;
		$(".defects").each(function(i, obj) {
			detailsArray[j] = $(this).val();
			j++;
		});
		
		var imagesArray = [];
		var j = 0;
		$(".capturedImage").each(function(i, obj) {
			imagesArray[j] = $(this).data('postFile');
			j++;
		});
		
		var endDate = new Date();
		
		$.ajax({
			url : gatewayURL + '/walkaround-check-results',
			cache : false,
			type : 'POST',
			contentType : 'application/json',
			data : JSON.stringify({
				'user' : $('#driver').val(),
				'vehicleReg' : $('#registration').val(),
				'mileage' : $('#mileage').val(),
				'results' : resultArray,
				'details' : detailsArray,
				'nil' : $('#nil').val(),
				'reportedTo' : $('#reportedTo').val(),
				'images' : imagesArray,
				'startDate' : getYYYYMMDD(startDate),
				'startTime' : getHHMMSS(startDate),
				'endDate' : getYYYYMMDD(endDate),
				'endTime' : getHHMMSS(endDate)
			}),
			success : function(data, status, xhr) {
				jQuery.mobile.hidePageLoadingMsg();
				onPostChecks(data);
			}
		});
	}
}


/**
 * Handle AJAX response for POST /login[/:login_id]
 * 
 * @param response JSON object with response
 */
function onPostChecks(response) {

	$.mobile.changePage('#page3');

}


//Position an input field
function positionInput() {

	var offset = $(this).offset().top;
	offset -= 40;
	$('html, body').animate({
		scrollTop: offset
	});
	
}


//Display Privacy Policy in the system browser 
function privacyPolicy() {

	// Display the go2stream.com privacy policy page in the system browser
	cordova.InAppBrowser.open('http://www.go2stream.com/privacy-policy', '_system');

} 


//Post any images to the image handler URL
function postImages() {
	
	/* IMPORTANT NOTE!  
	 * This processing uses the cordova-plugin-file plugin, installed as a dependency of the cordova-plugin-file-transfer plugin
	 * To get this working I had to do two things:
	 *  - Edit the FileWriter.js file with HexEdit to remove unwanted characters from the start of the file
	 *  - Edit the plugin.xml file to change the line that read ...
	 *      <js-module src="www/fileSystems.js" name="fileSystems" />
	 *    ... to read ...
	 *      <js-module src="www/fileSystems.js" name="fileSystems">
	 *          <merges target="window" />
	 *      </js-module>
	 */
	
	// Determine the root filename based on the reg no
	var fileRoot = 'DWCL-' + $('#registration').val().trim().toUpperCase().replace(/\s/g, '') + '-' + Math.floor(Date.now() / 1000);
	
	// Create server file name for each image
	$('.capturedImage').each( function() {
		
		// Create unique file name
		var fileName = fileRoot + '-' + $(this).attr('id').replace('#thumb', '') + '.jpg';
		
		// Stamp filename onto <img> so we can post it later
		$(this).data('postFile', fileName);
		
	});
	
	// Post each image
	$('.capturedImage').each( function() {
		
		// Get the local file path
		var filePath = $(this).attr('src');
		
		// Retrieve the server file name
		var fileName = $(this).data('postFile');

		// Post the file to the server
		var options = new FileUploadOptions();
		options.fileName = fileName;
		options.chunkedMode = false;
		var headers = new Object();
		headers.Accept = "image/jpeg";
		options.headers = headers;
		var ft = new FileTransfer();
		ft.upload(filePath, encodeURI(gatewayURL+'/image-upload'), uploadOK, uploadErr, options);
		
	});
		
}


// Upload OK dialog
function uploadOK(response) {
	//alert("Uploaded OK\n" + response.bytesSent + "\n" + response.responseCode + "\n" + response.response);
}


// Upload Error dialog
function uploadErr(error) {
	//alert("Error uploading file:\n" + error.code + "\n" + error.source + "\n" + error.target + "\n" + error.http_status + "\n" + error.body + "\n" + error.exception);
}


// Get the date in file format from a timestamp
function getYYYYMMDD(stamp) {
	return stamp.getFullYear().toString()+zeroPad(stamp.getMonth() + 1, 2)+zeroPad(stamp.getDate(), 2);
}


//Get the time in file format from a timestamp
function getHHMMSS(stamp) {
	return zeroPad(stamp.getHours(), 2)+zeroPad(stamp.getMinutes(), 2)+zeroPad(stamp.getSeconds(), 2);	
}


// Zero pad an integer
function zeroPad(num, places) {
	var zero = places - num.toString().length + 1;
	return Array(+(zero > 0 && zero)).join("0") + num;
}

//===========================================================================================================================================================================//


//TabBar support

window.CodiqaControls = {
  types: {},
  instances: {},

  define: function(type, control) {
    control._type = type;
    this.types[type] = control;
  },

  register: function(type, id, opts) {
    var instance = new this.types[type]();
    instance._type = type;
    instance._id = id;
    instance._opts = opts;
    this.instances[id] = instance;

    if(!this.types[type].prototype._isInited) {
      this.types[type].prototype.initType();
    }
    return instance;
  },

  init: function() {
    for(var type in this.types) {
      this.types[type].prototype.initType();
    }
  },

  refresh: function() {
    for(var x in this.instances) {
      this.instances[x].refresh && this.instances[x].refresh();
    }
  },

  callbackInit: function() {

  },

  getInstances: function(type) {
    var x, instance, instances = [];
    for(x in this.instances) {
      instance = this.instances[x];
      if(instance._type === type) {
        instances.push(instance);
      }
    }
    return instances;
  }

};


// Hide the Status bar
function hideStatusBar() {
	StatusBar.hide();
}


CodiqaControls.GoogleMap = function () {};
CodiqaControls.GoogleMap.prototype.initType = function() {
  if( window.CodiqaControls.getInstances('googlemaps').length ) {
    if(this._isInited) {
      if(window.google && window.google.maps) {
        CodiqaControls.GoogleMap.prototype.callbackInit();
      }
    } else {
      var script = document.createElement('script');
      script.type = "text/javascript";
      script.src = "https://maps.googleapis.com/maps/api/js?sensor=true&callback=CodiqaControls.types.googlemaps.prototype.callbackInit";
      document.getElementsByTagName("head")[0].appendChild(script);
      this._isInited = true;
    }
  }
};
CodiqaControls.GoogleMap.prototype.callbackInit = function() {
  var x, instances = window.CodiqaControls.getInstances('googlemaps');
  for(x = 0; x < instances.length; x++) {
    instances[x]._opts.ready(instances[x]);
  }
};
CodiqaControls.GoogleMap.prototype.refresh = function() {
  if( this.map && this.el && $(this.el).closest('.ui-page-active').length ) {
    google.maps.event.trigger(this.map, 'resize');
    this.center && this.map.setCenter(this.center);
  }
};
window.CodiqaControls.define('googlemaps', CodiqaControls.GoogleMap);


(function($) {
  $.widget('mobile.tabbar', $.mobile.navbar, {
    _create: function() {
      // Set the theme before we call the prototype, which will 
      // ensure buttonMarkup() correctly grabs the inheritied theme.
      // We default to the "a" swatch if none is found
      var theme = this.element.jqmData('theme') || "a";
      this.element.addClass('ui-footer ui-footer-fixed ui-bar-' + theme);

      // Make sure the page has padding added to it to account for the fixed bar
      this.element.closest('[data-role="page"]').addClass('ui-page-footer-fixed');


      // Call the NavBar _create prototype
      $.mobile.navbar.prototype._create.call(this);
    },

    // Set the active URL for the Tab Bar, and highlight that button on the bar
    setActive: function(url) {
      // Sometimes the active state isn't properly cleared, so we reset it ourselves
      this.element.find('a').removeClass('ui-btn-active ui-state-persist');
      this.element.find('a[href="' + url + '"]').addClass('ui-btn-active ui-state-persist');
    }
  });

  $(document).on('pagecreate create', function(e) {
    return $(e.target).find(":jqmData(role='tabbar')").tabbar();
  });
  
  $(document).on('pageshow', ":jqmData(role='page')", function(e) {
    // Grab the id of the page that's showing, and select it on the Tab Bar on the page
    var tabBar, id = $(e.target).attr('id');

    tabBar = $.mobile.activePage.find(':jqmData(role="tabbar")');
    if(tabBar.length) {
      tabBar.tabbar('setActive', '#' + id);
    }

    window.CodiqaControls.refresh();
  });

  window.CodiqaControls.init();
  
})(jQuery);